#include "BigExplosion.h"


BigExplosion::BigExplosion(){
	img = "Image/BigExplosion.png";
}

BigExplosion::BigExplosion(Vector2 Pos){
	pos = Pos;
	img = "Image/BigExplosion.png";
}

BigExplosion::~BigExplosion(){
	Mix_FreeChunk(sfx);
}

void BigExplosion::Init(){
	Unsolid::Init();
	
	sfx = Mix_LoadWAV("Sound/explosion.wav");
	soundMap();
	Mix_VolumeChunk(sfx, 75);
	Mix_PlayChannel(3, sfx, 0);
	anim = true;
	image->addAnim(0, 0, 40, 40, 14);
	timeExpAnim.start();
	frame = 0;
}

bool BigExplosion::Update(float pdt){
	Unsolid::Update(pdt);
	explosionSpeed();
	return false;
}

void BigExplosion::Draw(SDL_Surface* screen){
	Unsolid::Draw(screen);

}

void BigExplosion::explosionSpeed(){
	if(timeExpAnim.get_ticks() > 50){
		frame++;
		timeExpAnim.start();
	}
	if(frame >= 14)
		dead = true;
}

void BigExplosion::soundMap(){
	int soundLeft, soundRight;
	if(SCREEN_WIDTH / 2 < pos.x)
		soundLeft = (SCREEN_WIDTH / 2) - (pos.x / 2);
	else
		soundLeft = 255;

	if(SCREEN_WIDTH / 4 > pos.x)
		soundRight = pos.x / 2;
	else
		soundRight = 255;

	Mix_SetPanning(3, soundLeft, soundRight);
}