/*
	Skapar spelets objekt
											*/

#ifndef ENTITY_H
#define ENTITY_H

#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "Vector2.h"
#include "Screen.h"
#include "Timer2.h"

const float FRICTION = 0.995f;

class Entity{
public:
	virtual ~Entity(){};

	virtual void Init() = 0;
	virtual bool Update(float pdt) = 0;
	virtual void Draw(SDL_Surface* screen) = 0;

	bool dead;
	int size;
	Vector2 pos;
	Vector2 vel;
	std::string img;

protected:
	bool anim;
	int frame;
	bool initiated;
	SDL_Event event;
	Mix_Chunk* sfx;
};

#endif
