#include "EveHandler.h"


EveHandler::EveHandler(){
	timeButton.start();
}

EveHandler::~EveHandler(){
}

void EveHandler::AddEvent(SDL_Event* even){
	if(even->type == SDL_KEYDOWN)
		eve.push_back(even);
	else if(even->type == SDL_KEYUP){
		if(!RemoveKey(even->key.keysym.sym)){
			eve.push_back(even);
		}
	}
	else if(even->button.button == SDL_MOUSEBUTTONDOWN){
		eve.push_back(even);
	}
	else if(even->button.type ==  SDL_MOUSEBUTTONUP){
		if(!RemoveMouseButton())
			eve.push_back(even);
	}
	else{
		bool contains = false;
		for(unsigned int i = 0; i < eve.size(); i++){
			if(eve[i]->type == even->type)
				contains = true;	
		}
		if(!contains)
			eve.push_back(even);
	}


}

bool EveHandler::EventTypeExists(SDL_EventType type){
	for(unsigned int i = 0; i < eve.size(); i++){
		if(eve[i]->type == type)
			return true;
	}
	return false;
}

bool EveHandler::KeyHit(SDLKey Key){
	for(unsigned int i = 0; i < eve.size(); i++){
		if(eve[i]->key.keysym.sym == Key && eve[i]->type == SDL_KEYDOWN){
			RemoveKey(i);
			return true;
		}
	}
	return false;
}

bool EveHandler::KeyDown(SDLKey Key){
	for(unsigned int i = 0; i < eve.size(); i++){
		if(eve[i]->key.keysym.sym == Key && eve[i]->type == SDL_KEYDOWN){
			return true;
		}
	}
	return false;
}

bool EveHandler::KeyUp(SDLKey Key){
	for(unsigned int i = 0; i < eve.size(); i++){
		if((eve[i]->key.keysym.sym == Key) && (eve[i]->type == SDL_KEYUP)){
			RemoveKey(i);
			return true;
		}
	}
	return false;
}

bool EveHandler::mouseButtonHit(int button){
	for(unsigned int i = 0; i < eve.size(); i++){
		if((eve[i]->button.button == button) && (eve[i]->button.type == SDL_MOUSEBUTTONDOWN)){
			RemoveKey(i);
			return true;
		}
	}
	return false;
}

void EveHandler::setMousePos(int x, int y){
	mousePos.x = x;
	mousePos.y = y;
}

Vector2 EveHandler::getMousePos(){
	return mousePos;
}

bool EveHandler::RemoveKey(SDLKey Key){
	for(unsigned int i = 0; i < eve.size(); i++){
		if(eve[i]->key.keysym.sym == Key){
			return RemoveKey(i);
		}
	}
	return false;
}

bool EveHandler::RemoveMouseButton(){
	for(unsigned int i = 0; i < eve.size(); i++){
		if(eve[i]->button.button == SDL_BUTTON_LEFT){
			return RemoveKey(i);
		}
	}
	return false;
}

bool EveHandler::RemoveKey(int index){
	if(index < 0 || index >= eve.size())
		return false;
	SDL_Event *temp = eve.back();
	eve.back() = eve[index];
	eve[index] = temp;
	delete eve.back();
	eve.pop_back();
	return true;
}