#ifndef GAMEMANAGER_H
#define GAMEMANAGER_H

#include "SDL.h"
#include "SDL_mixer.h"
#include <vector>
#include "Vector2.h"
#include "Entity.h"
#include "GameScreen.h"
#include <string>
#include "EveHandler.h"
#include "FileManager.h"
#include "SDL_ttf.h"

class GameManager{
public:
	static GameManager &getSingleton();

	bool Init(int SCREEN_WIDTH, int SCREEN_HEIGHT, int SCREEN_BPP, std::string gameName);
	bool Update(float pdt);
	void Draw();

	void addEntity(Entity* entity, std::string name);
	void delEntity(Entity* entity, std::string name);
	void addGameScreen(GameScreen* pGameScreen, std::string name);
	GameScreen* getGameScreen(std::string name);
	void delGameScreen(std::string name);

	FileManager file;
	EveHandler eve;
private:
	GameManager();
	int screen_width, screen_height, screen_bpp;
	SDL_Surface* screen;
	bool initiated;
	std::vector<GameScreen*> gameScreens;
	float dt;
};

#endif