#ifndef GAMESCREEN_H
#define GAMESCREEN_H

#include "SDL.h"
#include <string>
#include <vector>
#include "Entity.h"

class GameScreen{
public:
	virtual ~GameScreen(){};

	virtual void Init(std::string pName) = 0;
	virtual bool Update(float pdt) = 0;
	virtual void Draw(SDL_Surface* screen) = 0;

	virtual std::string getName() = 0;
	virtual void addEntity(Entity* entity) = 0;
	virtual void delEntity(Entity* entity) = 0;

	bool visible;
	bool blockLowerUpdate;

protected:
	float dt;
	std::string name;
	std::vector<Entity*> entities;
	bool initiated;
};

#endif