#include "GameloopHandler.h"

GameloopHandler::GameloopHandler(){
	name = "temp";
	game = &GameManager::getSingleton();
	costRapidBullet = 100;
	costUpgradeGun = 100;
	countRapid = 0;
	countUpgrade = 0;
	timeRocket.start();
}

GameloopHandler::~GameloopHandler(){
}

void GameloopHandler::setName(std::string Name){
	name = Name;
}

bool GameloopHandler::Collision(Vector2 pos1, Vector2 pos2, int size1, int size2){
	pos1 += size1/2;
	pos2 += size2/2;
	return !(((pos1.x - size1 / 2) > (pos2.x + size2 / 2)) || ((pos1.x + size1 / 2) < (pos2.x - size2 / 2)) ||
			 ((pos1.y - size1 / 2) > (pos2.y + size2 / 2)) || ((pos1.y + size1 / 2) < (pos2.y - size2 / 2)));
}

void GameloopHandler::buy(Entity* ui, Entity* ship){
	int showH, showB, showN, showM;
	if((game->eve.KeyHit(SDLK_h)) && (((UI*)ui)->getMoney() >= 500) && (((UI*)ui)->getHealth() < 100)){
		((UI*)ui)->decMoney(500);
		((UI*)ui)->setHealth(100);
	}
	if((game->eve.KeyHit(SDLK_n)) && (((UI*)ui)->getMoney() >= costRapidBullet) && (countRapid < 14)){
		((UI*)ui)->decMoney(costRapidBullet);
		((Ship*)ship)->rapidBullet();
		costRapidBullet = (costRapidBullet * 1.5f);
		countRapid++;
	}
	if((game->eve.KeyHit(SDLK_b)) && (((UI*)ui)->getMoney() >= costUpgradeGun) && (countUpgrade < 17)){
		((UI*)ui)->decMoney(costUpgradeGun);
		((Ship*)ship)->upgradeGun();
		costUpgradeGun = (costUpgradeGun * 1.25);
		countUpgrade++;
	}
	if((game->eve.KeyHit(SDLK_m)) && (((UI*)ui)->getMoney() >= 25) && (timeRocket.get_ticks() > 1000)){
		((UI*)ui)->decMoney(25);		
		game->addEntity(new Rocket(Vector2(((Ship*)ship)->pos.x + ((Ship*)ship)->size + 5, ((Ship*)ship)->pos.y + (((Ship*)ship)->size  /2))), "Stage1");
		timeRocket.start();
	}

	if(((UI*)ui)->getMoney() >= 1000)
		showH = 1;
	else
		showH = 0;

	if((((UI*)ui)->getMoney() >= costRapidBullet) && (countRapid < 14))
		showN = 1;
	else if(countRapid == 14)
		showN = 2;
	else
		showN = 0;

	if((((UI*)ui)->getMoney() >= costUpgradeGun) && (countUpgrade < 17))
		showB = 1;
	else if(countUpgrade == 17)
		showB = 2;
	else
		showB = 0;

	if((((UI*)ui)->getMoney() >= 25) && (timeRocket.get_ticks() > 1000))
		showM = 1;
	else
		showM = 0;
	
	((UI*)ui)->getBuy(showH, showB, showN, showM);
	((UI*)ui)->getPrice(500, costUpgradeGun, costRapidBullet, 25);
}

void GameloopHandler::collisionShip(Entity* ui, Entity* ship, Entity* ent){
	if((typeid(*ent) == typeid(TheFoo)) || (typeid(*ent) == typeid(SmallMoney))  || 
		(typeid(*ent) == typeid(MedMoney)) || (typeid(*ent) == typeid(HugeMoney)) ||
		(typeid(*ent) == typeid(SpaceRockSmall)) || (typeid(*ent) == typeid(SpaceRockMedium)) ||
		(typeid(*ent) == typeid(SpaceRockBig)) || (typeid(*ent) == typeid(SwarmMother)) || 
		(typeid(*ent) == typeid(SwarmChildren)) || (typeid(*ent) == typeid(TheBoss)) ||
		(typeid(*ent) == typeid(GunArm)) || (typeid(*ent) == typeid(BulletEnemy))){
		if(Collision(ship->pos, ent->pos, ship->size, ent->size)){
			if(typeid(*ent) == typeid(TheFoo))	{
				((UI*)ui)->takeDmg(20);
				game->addEntity(new MedExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(SmallMoney)){
				((UI*)ui)->incMoney(((SmallMoney*)ent)->getWorth());
			}
			if(typeid(*ent) == typeid(MedMoney)){
				((UI*)ui)->incMoney(((MedMoney*)ent)->getWorth());
			}
			if(typeid(*ent) == typeid(HugeMoney)){
				((UI*)ui)->incMoney(((HugeMoney*)ent)->getWorth());
			}
			if(typeid(*ent) == typeid(SpaceRockSmall)){
				((UI*)ui)->takeDmg(25);
				game->addEntity(new MedExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(SpaceRockMedium)){
				((UI*)ui)->takeDmg(50);
				game->addEntity(new MedExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(SpaceRockBig)){
				((UI*)ui)->takeDmg(75);
				game->addEntity(new BigExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(SwarmMother)){
				((UI*)ui)->takeDmg(25);
				game->addEntity(new MedExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(SwarmChildren)){
				((UI*)ui)->takeDmg(20);
				game->addEntity(new SmallExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(GunArm)){
				((UI*)ui)->takeDmg(50);
				game->addEntity(new BigExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(TheBoss)){
				((UI*)ui)->takeDmg(200);
				game->addEntity(new BigExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			if(typeid(*ent) == typeid(BulletEnemy)){
				((UI*)ui)->takeDmg(((BulletEnemy*)ent)->getDamage());
				game->addEntity(new SmallExplosion(Vector2(ent->pos.x + (ent->size / 2), ent->pos.y + (ent->size / 2))), name);
			}
			ent->dead = true;
		}
		if(typeid(*ent) == typeid(TheBoss)){
			if(((TheBoss*)ent)->deathrayActive()){
				if((ship->pos.y > (((TheBoss*)ent)->pos.y + (((TheBoss*)ent)->size/2)- ship->size)) && (ship->pos.y < (((TheBoss*)ent)->pos.y + (((TheBoss*)ent)->size/2) + 6)))
				((UI*)ui)->takeDmg(1);
			}
		}

		if(((UI*)ui)->getHealth() <= 0)
			((Ship*)ship)->dead = true;
	}
}

void GameloopHandler::collisionShipBullet(Entity* ui, Entity* weapon, Entity* ent){
	if((typeid(*weapon) == typeid(RedBullet)) || (typeid(*weapon) == typeid(GreenBullet)) || 
		(typeid(*weapon) == typeid(Rocket))){
		if((typeid(*ent) == typeid(TheFoo)) || (typeid(*ent) == typeid(SpaceRockSmall)) || 
			(typeid(*ent) == typeid(SpaceRockMedium)) || (typeid(*ent) == typeid(SpaceRockBig)) ||
			(typeid(*ent) == typeid(SwarmMother)) || (typeid(*ent) == typeid(SwarmChildren)) ||
			(typeid(*ent) == typeid(TheBoss)) || (typeid(*ent) == typeid(GunArm))){

			// Collision with weapond against the solid
			if(Collision(weapon->pos, ent->pos, weapon->size, ent->size)){
				if(typeid(*ent) == typeid(TheFoo)){
					((TheFoo*)ent)->setDamage(((Weapon*)weapon)->getDamage());
				}
				if(typeid(*ent) == typeid(SpaceRockSmall)){
					((SpaceRockSmall*)ent)->setDamage(((Weapon*)weapon)->getDamage());
				}
				if(typeid(*ent) == typeid(SpaceRockMedium)){
					((SpaceRockMedium*)ent)->setDamage(((Weapon*)weapon)->getDamage());
				}
				if(typeid(*ent) == typeid(SpaceRockBig)){
					((SpaceRockBig*)ent)->setDamage(((Weapon*)weapon)->getDamage());
				}
				if(typeid(*ent) == typeid(SwarmMother)){
					((SwarmMother*)ent)->setDamage(((Weapon*)weapon)->getDamage());
					
				}
				if(typeid(*ent) == typeid(SwarmChildren)){
					((SwarmChildren*)ent)->setDamage(((Weapon*)weapon)->getDamage());
				}
				if(typeid(*ent) == typeid(TheBoss)){
					((TheBoss*)ent)->setDamage(((Weapon*)weapon)->getDamage());
				}
				if(typeid(*ent) == typeid(GunArm)){
					((GunArm*)ent)->setDamage(((Weapon*)weapon)->getDamage());
				}
				weapon->dead = true;

				if((typeid(*weapon) == typeid(RedBullet)) || (typeid(*weapon) == typeid(GreenBullet))){
					game->addEntity(new SmallExplosion(Vector2(weapon->pos.x + (weapon->size / 2), weapon->pos.y + (weapon->size / 2))), name);
				}
				if(typeid(*weapon) == typeid(Rocket)){
					game->addEntity(new MedExplosion(Vector2(weapon->pos.x + (weapon->size / 2), weapon->pos.y + (weapon->size / 2))), name);
				}

				// Calling the money classes if enemies dies
				if(((TheFoo*)ent)->getHealth() <= 0){
					((UI*)ui)->incScore(50);
					game->addEntity(new BigExplosion(Vector2(ent->pos.x + ent->size/2, ent->pos.y + ent->size/2)), name);
					for(int y = 0; y < 1 + rand() % 4; y++)
						game->addEntity(new SmallMoney(Vector2(ent->pos.x + rand() % ent->size, ent->pos.y + rand() % ent->size)), name);
					for(int y = 0; y < -2 + rand() % 4; y++)
						game->addEntity(new MedMoney(Vector2(ent->pos.x + rand() % ent->size, ent->pos.y + rand() % ent->size)), name);
					for(int y = 0; y < -5 + rand() % 7; y++)
						game->addEntity(new HugeMoney(Vector2(ent->pos.x + rand() % ent->size, ent->pos.y + rand() % ent->size)), name);
				}
			}
		}		
	}
}

void GameloopHandler::tracking(Vector2 spos, Entity* ent){
	// Tracking
	if((typeid(*ent) == typeid(SmallMoney)) || (typeid(*ent) == typeid(MedMoney)) || 
		(typeid(*ent) == typeid(HugeMoney))){
		if((((spos - ((SmallMoney*)ent)->getPos())) < 200) || 
			(((spos - ((MedMoney*)ent)->getPos())) < 200) || 
			(((spos - ((HugeMoney*)ent)->getPos())) < 200)){
			((SmallMoney*)ent)->hunt(spos);
			((MedMoney*)ent)->hunt(spos);
			((HugeMoney*)ent)->hunt(spos);
		}
	}
}

void GameloopHandler::rocketHuntEnemy(Entity* rocket, Entity* enemy){
	if((typeid(*rocket) == typeid(Rocket)) && (typeid(*enemy) == typeid(TheFoo)))
		((Rocket*)rocket)->hunt(((TheFoo*)enemy)->pos);

	if((typeid(*rocket) == typeid(Rocket)) && (typeid(*enemy) == typeid(SpaceRockSmall)))
		((Rocket*)rocket)->hunt(((SpaceRockSmall*)enemy)->pos);

	if((typeid(*rocket) == typeid(Rocket)) && (typeid(*enemy) == typeid(SpaceRockMedium)))
		((Rocket*)rocket)->hunt(((SpaceRockMedium*)enemy)->pos);

	if((typeid(*rocket) == typeid(Rocket)) && (typeid(*enemy) == typeid(SpaceRockBig)))
		((Rocket*)rocket)->hunt(((SpaceRockBig*)enemy)->pos);

	if((typeid(*rocket) == typeid(Rocket)) && (typeid(*enemy) == typeid(TheBoss)))
		((Rocket*)rocket)->hunt(((TheBoss*)enemy)->pos);

	if((typeid(*rocket) == typeid(Rocket)) && (typeid(*enemy) == typeid(GunArm)))
		((Rocket*)rocket)->hunt(((GunArm*)enemy)->pos);

}