#ifndef GAMELOOPHANDLER_H
#define GAMELOOPHANDLER_H

#include "SDL.h"
#include "GameManager.h"
#include <typeinfo>
#include "Timer2.h"
#include "UI.h"
#include "Ship.h"
#include "RedBullet.h"
#include "GreenBullet.h"
#include "BulletEnemy.h"
#include "Rocket.h"
#include "TheFoo.h"
#include "SpaceRockSmall.h"
#include "SpaceRockMedium.h"
#include "SpaceRockBig.h"
#include "SwarmChildren.h"
#include "SwarmMother.h"
#include "SmallExplosion.h"
#include "MedExplosion.h"
#include "BigExplosion.h"
#include "SmallMoney.h"
#include "MedMoney.h"
#include "HugeMoney.h"
#include "TheBoss.h"
#include "GunArm.h"

class GameloopHandler{
public:
	GameloopHandler();
	~GameloopHandler();
	bool Collision(Vector2 pos1, Vector2 pos2, int size1, int size2);

	void setName(std::string Name);
	void buy(Entity* ui, Entity* ship);
	void collisionShip(Entity* ui, Entity* ship, Entity* ent);
	void collisionShipBullet(Entity* ui, Entity* weapon, Entity* ent);
	void rocketHuntEnemy(Entity* rocket, Entity* enemy);
	void tracking(Vector2 spos, Entity* ent);

private:
	GameManager *game;
	
	int costRapidBullet, costUpgradeGun;
	int countRapid, countUpgrade;
	Timer2 timeRocket;
	std::string name;
};

#endif