#include "GunArm.h"


GunArm::GunArm(){
	img = "Image/BigBug.png";
}

GunArm::GunArm(Vector2 Pos){
	pos = Pos;
	img = "Image/BigBug.png";
}

GunArm::~GunArm(){
}

void GunArm::Init(){
	Enemy::Init();
	speed = 1;
	health = 300;
	size = 55;
	timeX.start();
	sfx = Mix_LoadWAV("Sound/bullet.wav");
	Mix_VolumeChunk(sfx, 25);
	timeShoot.start();
}

bool GunArm::Update(float pdt){
	Enemy::Update(pdt);
	move();
	shoot();
	if(pdt == 0)
		timeX.pause();
	else
		timeX.unpause();
	return false;
}

void GunArm::Draw(SDL_Surface* screen){
	Enemy::Draw(screen);
}

void GunArm::move(){
	vel.y = sinf(timeX.get_ticks()*0.0006) * 75;

	if(pos.x > (SCREEN_WIDTH - 150))
		pos.x -= speed;
}

int GunArm::getHealth(){
	return health;
}

void GunArm::shoot(){
	if(timeShoot.get_ticks() > 250){
		Mix_PlayChannel(3, sfx, 0);
		GameManager::getSingleton().addEntity(new BulletEnemy(Vector2(pos.x, pos.y + (size / 2) + 3)), "Stage1");
		timeShoot.start();
	}
}

void GunArm::soundMap(){
	int soundLeft, soundRight;
	if(SCREEN_WIDTH / 2 < pos.x)
		soundLeft = (SCREEN_WIDTH / 2) - (pos.x / 2);
	else
		soundLeft = 255;

	if(SCREEN_WIDTH / 4 > pos.x)
		soundRight = pos.x / 2;
	else
		soundRight = 255;

	Mix_SetPanning(3, soundLeft, soundRight);
}