/*
			SDL_Image wrapper
			created by Samuel Haggren
																		*/

#ifndef IMAGE_H
#define IMAGE_H

#include "SDL.h"
#include "SDL_image.h"
#include <string>
#include "Vector2.h"
#include <vector>
#include <sstream>
#include "SDL_ttf.h"
#include <stdexcept>

class Image{
public:
	Image();
	Image(std::string filename);
	Image(const Image& other); // Copy constructor
	~Image();

	const Image& operator=(const Image& other); // Copy operator

	void draw(Vector2 pos, SDL_Surface* screen);	// Draw your image to the screen	

	void addAnim(int x, int y, int w, int h, int frames);  // Add an animation, must be called before drawAnim! 
	void drawAnim(Vector2 pos, SDL_Surface* screen, int frame); // Draws the animation

	int w();
	int h();

	SDL_Surface* getSurface() const; // Returns your loaded image

private:
	std::vector<SDL_Rect*> clips;
	SDL_Surface* img;
};

//				<<<Check if SDL is property initilated before loading Image constructor! Or else the program will crash>>>

#endif