#include "LoadingScreen.h"


LoadingScreen::LoadingScreen(){
	
}


LoadingScreen::~LoadingScreen(){
}

void LoadingScreen::Init(std::string pName){
	name = pName;
	blockLowerUpdate = false;
	if(GameManager::getSingleton().getGameScreen("Stage1"))
		GameManager::getSingleton().delGameScreen("Stage1");
	if(GameManager::getSingleton().getGameScreen("MainScreen"))
		GameManager::getSingleton().delGameScreen("MainScreen");

	GameManager::getSingleton().addGameScreen(new Stage1(), "Stage1");

}

bool LoadingScreen::Update(float pdt){
	for(unsigned int i = 0; i < entities.size(); i++){
		if(entities[i]->Update(pdt))
			return true;

		if(entities[i]->dead){
			GameManager::getSingleton().delEntity(entities[i], name);
			continue;
		}
	}
	return false;
}

void LoadingScreen::Draw(SDL_Surface* screen){
	for(unsigned int i = 0; i < entities.size(); i++){
		entities[i]->Draw(screen);
	}
	SDL_FillRect(screen, &screen->clip_rect, SDL_MapRGB(screen->format, 0xFF, 0x00, 0x00));
}

std::string LoadingScreen::getName(){
	return name;
}

void LoadingScreen::addEntity(Entity *entity){
	entities.push_back(entity);
}

void LoadingScreen::delEntity(Entity* entity){
	for(unsigned int i = 0; i < entities.size(); i++) {
		if(entities[i] == entity) {
			Entity* temp = entities.back();
			entities.back() = entities[i];
			entities[i] = temp;
			delete entities.back();
			entities.pop_back();
			break;
		}
	}	
}