#include "SDL.h"
#include "GameManager.h"
#include "MainScreen.h"
#include "Timer2.h"
#include "Screen.h"

SDL_Surface* screen = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGTH, SCREEN_BPP, SDL_SWSURFACE);
Timer2 timer;
Timer2 timePause;
float dt;
bool pausing = false;

bool frameFunc(){
	dt = timer.get_ticks() / 1000.f;
	timer.start();

	if((GameManager::getSingleton().eve.KeyDown(SDLK_ESCAPE)) && (timePause.get_ticks() > 250) && 
		GameManager::getSingleton().getGameScreen("Stage1")){
		pausing = !pausing;
		timePause.start();
	}
	
	if(!GameManager::getSingleton().getGameScreen("Stage1"))
		pausing = false;

	if(pausing)
		dt = 0;

	if(GameManager::getSingleton().Update(dt))
		return true;

	if((!GameManager::getSingleton().getGameScreen("Stage1")) && (GameManager::getSingleton().eve.KeyDown(SDLK_ESCAPE)) || 
		GameManager::getSingleton().eve.EventTypeExists(SDL_QUIT))
		return true;	
	return false;
}

bool renderFunc(){
	SDL_FillRect(screen, &screen->clip_rect, SDL_MapRGB(screen->format, 0x00, 0x00, 0x00));
	GameManager::getSingleton().Draw();

	if(SDL_Flip(screen) == -1)
		return true;
	return false;
}

int main(int argc, char* args[]){
	bool exit = false;
	SDL_Event* eventet;
	SDL_Event focusScreen;

	timer.start();
	timePause.start();
	
	if(!GameManager::getSingleton().Init(SCREEN_WIDTH, SCREEN_HEIGTH, SCREEN_BPP, "Sams Schmup"))
		return 0;

	GameManager::getSingleton().addGameScreen(new MainScreen(), "MainScreen");

	while(!exit){	
		bool newEvents = true;
		while(newEvents){
			eventet = new SDL_Event();
			newEvents = SDL_PollEvent(eventet);
			// Controll if the window is focused, if not focused or minimized it will pause the game
			if(eventet->type == SDL_ACTIVEEVENT){
				if(eventet->active.state & SDL_APPACTIVE){
					if(eventet->active.gain == 0){
						pausing = true;
						Mix_PauseMusic();
					}
					else{
						pausing = false;
						if(Mix_PausedMusic() == 1)
							Mix_ResumeMusic();
					}
				}
				else if(eventet->active.state & SDL_APPINPUTFOCUS){
					if(eventet->active.gain == 0){
						pausing = true;
						Mix_PauseMusic();
					}
					else{
						pausing = false;
						if(Mix_PausedMusic() == 1)
							Mix_ResumeMusic();
					}
				}
			}
			if(eventet->type == SDL_MOUSEMOTION)
				GameManager::getSingleton().eve.setMousePos(eventet->motion.x, eventet->motion.y);
			if(newEvents)
				GameManager::getSingleton().eve.AddEvent(eventet);
			else
				delete eventet;	
		}
		if(frameFunc())
			exit = true;
		if(renderFunc())
			exit = true;
	}

	TTF_Quit();
	Mix_CloseAudio();
	SDL_Quit();

	return 0;
}