#ifndef MAINSCREEN_H
#define MAINSCREEN_H

#include "GameScreen.h"
#include "GameManager.h"
#include "LoadingScreen.h"
#include "SDL_ttf.h"
#include <string>

class MainScreen : public GameScreen{
public:
	MainScreen();
	~MainScreen();

	void Init(std::string pName); 
	bool Update(float pdt);
	void Draw(SDL_Surface* screen);
	std::string getName();
	void addEntity(Entity* entity);
	void delEntity(Entity* entity);

private:
	TTF_Font* fontBig;
	TTF_Font* fontMed;
	Mix_Music *music;
	Timer2 timeclick;

	bool quit, info, credits;

	SDL_Rect rectPlay, rectInfo, rectExit;
	Vector2 mousePos;

	SDL_Surface* txt;
	SDL_Rect rect;

	void menu(SDL_Surface* screen);
	void showInfo(SDL_Surface* screen);
	void showCredits(SDL_Surface* screen);
};

#endif