#include "MedExplosion.h"


MedExplosion::MedExplosion(){
	img = "Image/MedExplosion.png";
}

MedExplosion::MedExplosion(Vector2 Pos){
	pos = Pos;
	img = "Image/MedExplosion.png";
}

MedExplosion::~MedExplosion(){
	Mix_FreeChunk(sfx);
}

void MedExplosion::Init(){
	Unsolid::Init();
	
	sfx = Mix_LoadWAV("Sound/explosion.wav");
	soundMap();
	Mix_VolumeChunk(sfx, 50);
	Mix_PlayChannel(2, sfx, 0);
	anim = true;
	image->addAnim(0, 0, 20, 21, 9);
	timeExpAnim.start();
	frame = 0;
}

bool MedExplosion::Update(float pdt){
	Unsolid::Update(pdt);
	explosionSpeed();
	return false;
}

void MedExplosion::Draw(SDL_Surface* screen){
	Unsolid::Draw(screen);

}

void MedExplosion::explosionSpeed(){
	if(timeExpAnim.get_ticks() > 50){
		frame++;
		timeExpAnim.start();
	}
	if(frame >= 9)
		dead = true;
}

void MedExplosion::soundMap(){
	int soundLeft, soundRight;
	if(SCREEN_WIDTH / 2 < pos.x)
		soundLeft = (SCREEN_WIDTH / 2) - (pos.x / 2);
	else
		soundLeft = 255;

	if(SCREEN_WIDTH / 4 > pos.x)
		soundRight = pos.x / 2;
	else
		soundRight = 255;

	Mix_SetPanning(3, soundLeft, soundRight);
}