#include "Rocket.h"


Rocket::Rocket(){
	img = "Image/Rocket.png";
}

Rocket::Rocket(Vector2 Pos){
	pos = Pos;
	img = "Image/Rocket.png";
}

Rocket::~Rocket(){
}

void Rocket::Init(){
	Weapon::Init();
	size = 16;
	pos.y -= (size / 2);
	vel.x = 500;
	damage = 25;
	huntSpeed = 5;
	speed = 100;
	anim = true;
	
	image->addAnim(0, 0, 18, 10, 2);
}

bool Rocket::Update(float pdt){
	Weapon::Update(pdt);
	drawSmoke();
	move();
	return false;
}

void Rocket::Draw(SDL_Surface* screen){
	Weapon::Draw(screen);
}

void Rocket::move(){
	if(vel.x > 0)
		frame = 1;
	else
		frame = 0;
}

void Rocket::hunt(Vector2 hunted){
	huntVel = (hunted - pos).Normalize();
	vel += huntVel * huntSpeed;
}

void Rocket::drawSmoke(){
	if(vel.x > 0)
		GameManager::getSingleton().addEntity(new SmokeTrail(Vector2(pos.x, pos.y + 5)), "Stage1"); 
	else
		GameManager::getSingleton().addEntity(new SmokeTrail(Vector2(pos.x + 10, pos.y + 5)), "Stage1"); 
}