#include "Stage1.h"

Stage1::Stage1(){
	game = &GameManager::getSingleton();
}

Stage1::~Stage1(){
	Mix_FreeMusic(music);
	for(unsigned int i = 0; i < entities.size(); i++){
		if(entities[i]->dead){
			delEntity(entities[i]);
			continue;
		}
	}
}

void Stage1::Init(std::string pName){
	name = pName;
	visible = true;
	blockLowerUpdate = false;
	shipDead = false;
	won = false;

	if(GameManager::getSingleton().getGameScreen("LoadingScreen"))
		GameManager::getSingleton().delGameScreen("LoadingScreen");

	glh.setName(name);
	sh.setName(name);
	
	music = Mix_LoadMUS("Sound/Elwood-Stompin_little_scouts.mp3");
 	Mix_PlayMusic(music, -1);

	game->addEntity(new Background(), name);
	game->addEntity(new BackgroundPlanet(), name);
	game->addEntity(new BackgroundLayer2(), name);
	game->addEntity(new Ship(), name);
	game->addEntity(new UI(), name);
}

bool Stage1::Update(float pdt){
	if(shipDead)
		pdt = 0;
   	for(unsigned int u = 0; u < entities.size(); u++){
		if(typeid(*entities[u]) == typeid(UI)){
			if(entities[u]->Update(pdt))
				return true;
			for(unsigned int i = 0; i < entities.size(); i++){
				if(entities[i]->Update(pdt))
					return true;
				for(unsigned int k = 0; k < entities.size(); k++){
					if(typeid(*entities[i]) == typeid(Ship)){
						glh.buy(entities[u], entities[i]); // Buymenu for the game..
						glh.collisionShip(entities[u], entities[i], entities[k]); // Everything that collides with the ship
						glh.tracking(((Ship*)entities[i])->getPos(), entities[k]); // Everything that tracks the ship
						dh.setShipPos(((Ship*)entities[i])->getPos()); // Get ships position for the DeadHandler class
						if(dh.deadShip(entities[i]))
							shipDead = true;
						((Ship*)entities[i])->setWon(won);
						((UI*)entities[u])->setWon(won);
					}
					glh.collisionShipBullet(entities[u], entities[i], entities[k]);	 // Everything that the bullets are colliding with
					glh.rocketHuntEnemy(entities[i], entities[k]); // The rocket hunts the enemy 
					dh.handler(entities[k]); // Handle what happends when objects dies
					if(dh.deadBoss(entities[k]))
						won = true;
					if(entities[k]->dead){
						game->delEntity(entities[k], name);
						continue;
					}
				}
				if(entities[i]->dead){
					game->delEntity(entities[i], name);
					continue;
				}	
			}
			if(((UI*)entities[u])->getRestart())
				game->addGameScreen(new LoadingScreen(), "LoadingScreen");
			if(((UI*)entities[u])->getQuit())
				game->addGameScreen(new MainScreen(), "MainScreen");
			
		}	
	}

	//pushLast();

	if(!won || shipDead)
		sh.spawn(pdt); // Spawn new entities
	return false;
}

void Stage1::Draw(SDL_Surface* screen){
	for(unsigned int i = 0; i < entities.size(); i++){
		entities[i]->Draw(screen);
	}
}

std::string Stage1::getName(){
	return name;
}

void Stage1::addEntity(Entity *entity){
	entities.push_back(entity);
}

void Stage1::delEntity(Entity* entity){
	for(unsigned int i = 0; i < entities.size(); i++) {
		if(entities[i] == entity) {
			Entity* temp = entities.back();
			entities.back() = entities[i];
			entities[i] = temp;
			delete entities.back();
			entities.pop_back();
			break;
		}
	}	
}

void Stage1::pushLast(){
	for(unsigned int i = 0; i < entities.size(); i++){
		if(typeid(*entities[i]) == typeid(UI)){
			Entity* temp =  entities.back();
			if(typeid(*entities.back()) != typeid(UI)){
				entities.back() = entities[i];
				entities[i] = temp;
				break;
			}
		}
	}
}