#include "SwarmMother.h"


SwarmMother::SwarmMother(){
	img = "Image/BigBug.png";
}

SwarmMother::SwarmMother(Vector2 Pos){
	pos = Pos;
	img = "Image/BigBug.png";
}

SwarmMother::~SwarmMother(){
}

void SwarmMother::Init(){
	Enemy::Init();
	speed = 125;
	health = 35;
	size = 64;
	timeX.start();
	
	spawnChildren();
}

bool SwarmMother::Update(float pdt){
	Enemy::Update(pdt);
	move();
	if(dead)
		dead = true;
	
	if(pdt == 0)
		timeX.pause();
	else
		timeX.unpause();
	return false;
}

void SwarmMother::Draw(SDL_Surface* screen){
	Enemy::Draw(screen);
}

void SwarmMother::move(){
	vel.x = -speed;
	vel.y = sinf(timeX.get_ticks()*0.002) * 100;
}

int SwarmMother::getHealth(){
	return health;
}

void SwarmMother::spawnChildren(){
	for(int i = 0; i < 10; i++){
		GameManager::getSingleton().addEntity(new SwarmChildren(Vector2(pos.x + 80 + 64*i/2 + rand()% 20, pos.y + rand()%50)), "Stage1");
	}
}

bool SwarmMother::getDead(){
	return dead;
}