#include "TheBoss.h"

TheBoss::TheBoss(){
	charge = GameManager::getSingleton().file.get("Image/ChargingBeam.png");
	ray = GameManager::getSingleton().file.get("Image/Ray.png");
	img = "Image/TheBoss.png";
}

TheBoss::TheBoss(Vector2 Pos){
	pos = Pos;
	charge = GameManager::getSingleton().file.get("Image/ChargingBeam.png");
	ray = GameManager::getSingleton().file.get("Image/Ray.png");
	img = "Image/TheBoss.png";
}

TheBoss::~TheBoss(){
	Mix_Pause(4);
	Mix_FreeChunk(sfx);
}


void TheBoss::Init(){
	Enemy::Init();
	speed = 1;
	health = 1000;
	size = 128;
	anim = true;
	deathrayAct = false;
	
	image->addAnim(0, 0, 260, 127, 2);
	
	timeCharge.start();
	timeChargeBlink.start();
	timeX.start();
	timeRay.pause();
	sfx = Mix_LoadWAV("Sound/Raybeam.wav");
}

bool TheBoss::Update(float pdt){
	Enemy::Update(pdt);
	move();
	if(pdt == 0)
		timeX.pause();
	else
		timeX.unpause();
	return false;
}

void TheBoss::Draw(SDL_Surface* screen){
	Enemy::Draw(screen);
	chargingMaLasor(screen);
	deathray(screen);
}

void TheBoss::move(){
	vel.y = sin(timeX.get_ticks()*0.0006f) * 75;

	if(pos.x > (SCREEN_WIDTH - 300))
		pos.x -= speed;
}

int TheBoss::getHealth(){
	return health;
}

void TheBoss::chargingMaLasor(SDL_Surface* screen){
	if((timeCharge.get_ticks() > 9450) && (timeCharge.get_ticks() < 9500))
		Mix_PlayChannel(4, sfx, 0);
	if((timeCharge.get_ticks() > 10000) && (timeCharge.get_ticks() < 13000)){
		timeRay.start();
		if(timeChargeBlink.get_ticks() > 100){
			timeChargeBlink.start();
			for(int i = 0; i < 8; i++){
				GameManager::getSingleton().file.get("Image/ChargingBeam.png")->draw(Vector2(pos.x - 50 - (100 * i), pos.y + (size/2) - 11), screen);
			}
			for(int i = 0; i < 8; i++){
				GameManager::getSingleton().file.get("Image/ChargingBeam.png")->draw(Vector2(pos.x - 50 - (100 * i), pos.y + (size/2) + 6), screen);
			}
		}
	}
}

void TheBoss::deathray(SDL_Surface* screen){
	if((timeRay.get_ticks() > 100) && (timeRay.get_ticks() < 200)){
		SDL_FillRect(screen, &screen->clip_rect, SDL_MapRGB(screen->format, 0xFF, 0xFF, 0xFF));
	}
	if((timeRay.get_ticks() > 200) && (timeRay.get_ticks() < 8000)){
		deathrayAct = true;
		frame = 1;
		for(int i = 0; i < 16; i++){
			GameManager::getSingleton().file.get("Image/Ray.png")->draw(Vector2(pos.x - 75 -(75 * i), pos.y + (size/2) - 11), screen);
		}
	}
	else if(timeRay.get_ticks() > 8000){
		timeRay.start();
		timeRay.pause();
		timeCharge.start();
	}
	else{
		frame = 0;
		deathrayAct = false;
	}
}

bool TheBoss::deathrayActive(){
	return deathrayAct;
}

bool TheBoss::isDead(){
	return dead;
}