#include "UI.h"


UI::UI(){
	img = "Image/UIBackground.png";
	GameManager::getSingleton().file.get("Image/ButtonH.png");
	GameManager::getSingleton().file.get("Image/ButtonB.png");
	GameManager::getSingleton().file.get("Image/ButtonN.png");
	GameManager::getSingleton().file.get("Image/ButtonM.png");
	GameManager::getSingleton().file.get("Image/Replay.png");
	GameManager::getSingleton().file.get("Image/ExitButton.png");
}

UI::~UI(){
}

void UI::Init(){
	Unsolid::Init();
	hp = game->file.get("Image/Health.png");
	sh = game->file.get("Image/Shield.png");
	
	GameManager::getSingleton().file.get("Image/ButtonH.png")->addAnim(0, 0, 25, 25, 3);
	GameManager::getSingleton().file.get("Image/ButtonB.png")->addAnim(0, 0, 25, 25, 3);
	GameManager::getSingleton().file.get("Image/ButtonN.png")->addAnim(0, 0, 25, 25, 3);
	GameManager::getSingleton().file.get("Image/ButtonM.png")->addAnim(0, 0, 25, 25, 3);
	GameManager::getSingleton().file.get("Image/ExitButton.png")->addAnim(0, 0, 128, 100, 2);
	GameManager::getSingleton().file.get("Image/Replay.png")->addAnim(0, 0, 193, 93, 2);

	buttonReplay.x = (SCREEN_WIDTH / 3)  - (GameManager::getSingleton().file.get("Image/Replay.png")->w() / 4);
	buttonReplay.y = SCREEN_HEIGTH - (SCREEN_HEIGTH / 3);
	buttonReplay.w = GameManager::getSingleton().file.get("Image/Replay.png")->w() / 2;
	buttonReplay.h = GameManager::getSingleton().file.get("Image/Replay.png")->h();

	buttonExit.x = SCREEN_WIDTH - (SCREEN_WIDTH / 3) - (GameManager::getSingleton().file.get("Image/Exitbutton.png")->w() / 4);
	buttonExit.y = SCREEN_HEIGTH - (SCREEN_HEIGTH / 3);
	buttonExit.w = GameManager::getSingleton().file.get("Image/ExitButton.png")->w() / 2;
	buttonExit.h = GameManager::getSingleton().file.get("Image/ExitButton.png")->h();


	timerHealth.start();
	health = 100;
	shield = 100;
	money = 0;
	moneyRect.x = 500;
	moneyRect.y = 20;
	scoreRect.x = 800;
	scoreRect.y = 20;
	pause = false;
	shipDead = false;
	quit = false;
	restart = false;
	win = false;
	score = 0;
	font = TTF_OpenFont("pirulen.ttf", 28);
	font2 = TTF_OpenFont("pirulen.ttf", 8);
}

bool UI::Update(float pdt){
	Unsolid::Update(pdt);
	if(pdt == 0)
		pause = true;
	else 
		pause = false;
	
	return false;
}

void UI::Draw(SDL_Surface* screen){
	Unsolid::Draw(screen);
	showHealth(screen);
	showMoney(screen);
	showScore(screen);
	showBuy(screen);
	showBuyText(screen);
	if(pause && !shipDead)
		showPause(screen);
	if(shipDead || win)
		showGameOver(screen);
	GameManager::getSingleton().eve.mouseButtonHit(1); // Ugly fix to clear the array from mouse button hit, but it works.
}

void UI::showHealth(SDL_Surface* screen){
	for(int i = 0; i < health; i++)
		hp->draw(Vector2(50 + (i * 2), 7), screen);

	for(int i = 0; i < shield; i++)
		sh->draw(Vector2(50 + (i * 2), 39), screen);

	if(pause)
		timerHealth.pause();
	else
		timerHealth.unpause();

	if((shield < 99) && (timerHealth.get_ticks() > 3000) && !pause)
		shield +=  0.15f;

	if(health <= 0)
		shipDead = true;

	// THE BIG RED BUTTON
	if(GameManager::getSingleton().eve.KeyHit(SDLK_q))
		health -= 200;
}

void UI::showMoney(SDL_Surface* screen){
	SDL_Color textColor = {255, 255, 255};
	std::stringstream stream;
	stream << money << " $";
	txt = TTF_RenderText_Solid(font, stream.str().c_str(), textColor);

	SDL_BlitSurface(txt, NULL, screen, &moneyRect);
	SDL_FreeSurface(txt);
}

void UI::showScore(SDL_Surface* screen){
	SDL_Color textColor = {255, 255, 255};
	std::stringstream stream;
	stream << score << " P";
	txt = TTF_RenderText_Solid(font, stream.str().c_str(), textColor);

	SDL_BlitSurface(txt, NULL, screen, &scoreRect);
	SDL_FreeSurface(txt);
}

void UI::showPause(SDL_Surface* screen){
	SDL_Color textColor = {255, 255, 255};
	txt = TTF_RenderText_Solid(font, "PAUSED", textColor);
	rectPause.x = (SCREEN_WIDTH / 2) - (txt->w / 2);
	rectPause.y = SCREEN_HEIGTH / 4;
	SDL_BlitSurface(txt, NULL, screen, &rectPause);
	SDL_FreeSurface(txt);

	mousePos = GameManager::getSingleton().eve.getMousePos();

	if((mousePos.x > buttonReplay.x) && (mousePos.x < buttonReplay.x + buttonReplay.w) && (mousePos.y > buttonReplay.y) && (mousePos.y < buttonReplay.y + buttonReplay.h)){
		GameManager::getSingleton().file.get("Image/Replay.png")->drawAnim(Vector2(buttonReplay.x, buttonReplay.y), screen, 1);
		if(GameManager::getSingleton().eve.mouseButtonHit(1))
			restart = true;	
	}
	else
		GameManager::getSingleton().file.get("Image/Replay.png")->drawAnim(Vector2(buttonReplay.x, buttonReplay.y), screen, 0);
		
	if((mousePos.x > buttonExit.x) && (mousePos.x < buttonExit.x + buttonExit.w) && (mousePos.y > buttonExit.y) && (mousePos.y < buttonExit.y + buttonExit.h)){
		GameManager::getSingleton().file.get("Image/ExitButton.png")->drawAnim(Vector2(buttonExit.x, buttonExit.y), screen, 1);
		if(GameManager::getSingleton().eve.mouseButtonHit(1)){
			quit = true;
		}
	}
	else
		GameManager::getSingleton().file.get("Image/ExitButton.png")->drawAnim(Vector2(buttonExit.x, buttonExit.y), screen, 0);
}

void UI::showBuy(SDL_Surface* screen){
	GameManager::getSingleton().file.get("Image/ButtonH.png")->drawAnim(Vector2(335, 10), screen, frameH);  
	GameManager::getSingleton().file.get("Image/ButtonB.png")->drawAnim(Vector2(300, 45), screen, frameB);  
	GameManager::getSingleton().file.get("Image/ButtonN.png")->drawAnim(Vector2(335, 45), screen, frameN);  
	GameManager::getSingleton().file.get("Image/ButtonM.png")->drawAnim(Vector2(370, 45), screen, frameM);  
}

void UI::showBuyText(SDL_Surface* screen){
	SDL_Color textColor = {255, 255, 255};
	std::stringstream streamh, streamb, streamn, streamm;
	streamh << priceH;
	rectbh.x = 335;
	rectbh.y = 0;
	
	txt= TTF_RenderText_Solid(font2, streamh.str().c_str(), textColor);
	SDL_BlitSurface(txt, NULL, screen, &rectbh);
	SDL_FreeSurface(txt);

	streamb << priceB;
	rectbb.x = 300;
	rectbb.y = 35;
	
	txt= TTF_RenderText_Solid(font2, streamb.str().c_str(), textColor);
	SDL_BlitSurface(txt, NULL, screen, &rectbb);
	SDL_FreeSurface(txt);
	
	streamn << priceN;
	rectbb.x = 335;
	rectbb.y = 35;
	
	txt= TTF_RenderText_Solid(font2, streamn.str().c_str(), textColor);
	SDL_BlitSurface(txt, NULL, screen, &rectbb);
	SDL_FreeSurface(txt);

	streamm << priceM;
	rectbb.x = 370;
	rectbb.y = 35;
	
	txt= TTF_RenderText_Solid(font2, streamm.str().c_str(), textColor);
	SDL_BlitSurface(txt, NULL, screen, &rectbb);
	SDL_FreeSurface(txt);
}

void UI::showGameOver(SDL_Surface* screen){
	SDL_Color textColor = {255, 255, 255};

	if(win){
		txt = TTF_RenderText_Solid(font, "Congrats! You just saved the universe!", textColor);
		rectGO.x = (SCREEN_WIDTH / 2) - (txt->w / 2);
		rectGO.y = SCREEN_HEIGTH / 4;
		SDL_BlitSurface(txt, NULL, screen, &rectGO);
		SDL_FreeSurface(txt);
	}
	else{
		txt = TTF_RenderText_Solid(font, "GAME OVER", textColor);
		rectGO.x = (SCREEN_WIDTH / 2) - (txt->w / 2);
		rectGO.y = SCREEN_HEIGTH / 4;
		SDL_BlitSurface(txt, NULL, screen, &rectGO);
		SDL_FreeSurface(txt);
	}

	txt = TTF_RenderText_Solid(font, "Do you want to play again?", textColor);
	rectGO.x = (SCREEN_WIDTH / 2) - (txt->w / 2);
	rectGO.y = SCREEN_HEIGTH / 3;
	SDL_BlitSurface(txt, NULL, screen, &rectGO);
	SDL_FreeSurface(txt);

	mousePos = GameManager::getSingleton().eve.getMousePos();

	if((mousePos.x > buttonReplay.x) && (mousePos.x < buttonReplay.x + buttonReplay.w) && (mousePos.y > buttonReplay.y) && (mousePos.y < buttonReplay.y + buttonReplay.h)){
		GameManager::getSingleton().file.get("Image/Replay.png")->drawAnim(Vector2(buttonReplay.x, buttonReplay.y), screen, 1);
		if(GameManager::getSingleton().eve.mouseButtonHit(1)){
			restart = true;
		}
	}
	else
		GameManager::getSingleton().file.get("Image/Replay.png")->drawAnim(Vector2(buttonReplay.x, buttonReplay.y), screen, 0);
		
	if((mousePos.x > buttonExit.x) && (mousePos.x < buttonExit.x + buttonExit.w) && (mousePos.y > buttonExit.y) && (mousePos.y < buttonExit.y + buttonExit.h)){
		GameManager::getSingleton().file.get("Image/ExitButton.png")->drawAnim(Vector2(buttonExit.x, buttonExit.y), screen, 1);
		if(GameManager::getSingleton().eve.mouseButtonHit(1)){
			quit = true;
		}
	}
	else
		GameManager::getSingleton().file.get("Image/ExitButton.png")->drawAnim(Vector2(buttonExit.x, buttonExit.y), screen, 0);
}

void UI::getBuy(int showH, int showB, int showN, int showM){
	frameH = showH;
	frameB = showB;
	frameN = showN;
	frameM = showM;	
}

void UI::takeDmg(int damage){
	timerHealth.start();
	int overKill = 0;
	if(damage > shield)
		overKill = damage - shield;
	if(shield > 0)
		shield -= damage;
	if(overKill > 0)
		health -= overKill;
}

void UI::getPrice(int PriceH, int PriceB, int PriceN, int PriceM){
	priceH = PriceH;
	priceB = PriceB;
	priceN = PriceN;
	priceM = PriceM;
}

void UI::setHealth(int Health){
	health = Health;
}

int UI::getHealth(){
	return health;
}

void UI::incMoney(int Money){
	money += Money;
}

void UI::decMoney(int Money){
	money -= Money;
}

int UI::getMoney(){
	return money;
}

void UI::incScore(int Score){
	score += Score;
}

bool UI::getRestart(){
	return restart;
}

bool UI::getQuit(){
	return quit;
}

bool UI::getWon(){
	return win;
}

void UI::setWon(bool won){
	win = won;
}