#ifndef UI_H
#define UI_H
	
#include "Unsolid.h"
#include "SDL_ttf.h"
#include <string>
#include <sstream>

class UI : public Unsolid{
public:
	UI();
	~UI();
	void Init(); 
	bool Update(float pdt);
	void Draw(SDL_Surface* screen);


	void takeDmg(int damage);
	void setHealth(int Health);
	int getHealth();

	void incMoney(int Money);
	void decMoney(int Money);
	int getMoney();

	void incScore(int Score); 
	void getBuy(int showH, int showB, int showN, int showM);
	void getPrice(int PriceH, int PriceB, int PriceN, int PriceM);

	bool getRestart();
	bool getQuit();

	bool getWon();
	void setWon(bool won);

private:
	float health, shield;
	int money;
	int score;
	int mouseX, mouseY;
	Vector2 mousePos;
	bool pause;
	bool shipDead;
	bool quit, restart, win;
	int frameH, frameB, frameN, frameM;

	Image *hp, *sh;
	Image *mon, *sco;
	std::string buyH, buyB, buyN, buyM;
	int priceH, priceB, priceN, priceM;
	Timer2 timerHealth;
	TTF_Font* font;
	TTF_Font* font2;

	SDL_Surface* txt;
	SDL_Rect rectbh;
	SDL_Rect rectbb;
	SDL_Rect rectbn;
	SDL_Rect rectbm;

	SDL_Rect moneyRect;
	SDL_Rect scoreRect;
	SDL_Rect rectPause;
	SDL_Rect rectGO;
	SDL_Rect buttonExit;
	SDL_Rect buttonReplay;

	void showHealth(SDL_Surface* screen);
	void showMoney(SDL_Surface* screen);
	void showScore(SDL_Surface* screen);
	void showPause(SDL_Surface* screen);
	void showBuy(SDL_Surface* screen);
	void showBuyText(SDL_Surface* screen);
	void showGameOver(SDL_Surface* screen);
};

#endif