#ifndef VECTOR2_H
#define VECTOR2_H

#include <string>

class Vector2{
public:
	Vector2();
	Vector2(float xy);
	Vector2(float x, float y);
	Vector2(int xy);
	Vector2(int x, int y);
	Vector2(const Vector2& vector2);
	
	bool operator==(const Vector2& vector2) const;
	bool operator!=(const Vector2& vector2) const;
	bool operator<(const Vector2& vector2) const;
	bool operator>(const Vector2& vector2) const;
	bool operator<=(const Vector2& vector2) const;
	bool operator>=(const Vector2& vector2) const;
	
	const Vector2& operator+=(const Vector2& vector2);
	const Vector2& operator-=(const Vector2& vector2);
	const Vector2& operator*=(const Vector2& vector2);
	const Vector2& operator/=(const Vector2& vector2);
	
	Vector2 operator+(const Vector2& vector2) const;
	Vector2 operator-(const Vector2& vector2) const;
	Vector2 operator*(const Vector2& vector2) const;
	Vector2 operator/(const Vector2& vector2) const;
	
	const Vector2& operator*=(const float scalar);
	const Vector2& operator/=(const float scalar);
	Vector2 operator*(const float scalar) const;
	Vector2 operator/(const float scalar) const;
	const Vector2& operator*=(const int scalar);
	const Vector2& operator/=(const int scalar);
	Vector2 operator*(const int scalar) const;
	Vector2 operator/(const int scalar) const;
	
	static float Distance(const Vector2& from, const Vector2& to);
	float Distance(const Vector2& to);
	static float Dot(const Vector2& a, const Vector2& b);
	float Dot(const Vector2& b);
	float Length() const;
	Vector2 Normalize() const;
	Vector2 Conjugate() const;
	int Size() const;
	
	float x;
	float y;
};

#endif